<?php
if (!defined('ABSPATH')) {
    exit;
}
global $hook_suffix;
add_action('wp_ajax_eh_bep_get_attributes_action', 'eh_bep_get_attributes_action_callback');
add_action('wp_ajax_eh_bep_all_products', 'eh_bep_list_table_all_callback');
add_action('wp_ajax_eh_bep_count_products', 'eh_bep_count_products_callback');
add_action('wp_ajax_eh_bep_clear_products', 'eh_clear_all_callback');
add_action('wp_ajax_eh_bep_update_products', 'eh_bep_update_product_callback');
add_action('wp_ajax_eh_bep_filter_products', 'eh_bep_search_filter_callback');
add_action('wp_ajax_eh_bulk_edit_display_count', 'eh_bulk_edit_display_count_callback');

function eh_bulk_edit_display_count_callback() {
    check_ajax_referer('ajax-eh-bep-nonce', '_ajax_eh_bep_nonce');
    $value = sanitize_text_field($_POST['row_count']);
    update_option('eh_bulk_edit_table_row', $value);
    die('success');
}

function eh_bep_count_products_callback() {
    $filtered_products=xa_bep_get_selected_products();
    check_ajax_referer('ajax-eh-bep-nonce', '_ajax_eh_bep_nonce');
    $count_product_arr = array('product' => count($filtered_products));
    die(json_encode($count_product_arr));
}

function eh_bep_get_attributes_action_callback()
{   
    $attribute_name = $_POST['attrib'];
    $cat_args       = array(
        'hide_empty' => false,
        'order' => 'ASC'
    );
    $attributes     = wc_get_attribute_taxonomies();
    foreach ($attributes as $key => $value) {
        if ($attribute_name == $value->attribute_name) {
            $attribute_name  = $value->attribute_name;
            $attribute_label = $value->attribute_label;
        }
    }
    $attribute_value = get_terms('pa_' . $attribute_name, $cat_args);
    $return          = "<optgroup label='" . $attribute_label . "' id='grp_" . $attribute_name . "'>";
    foreach ($attribute_value as $key => $value) {
        $return .= "<option value=\"'pa_" .$attribute_name. ":" . $value->slug . "'\">" . $value->name . "</option>";
    }
    $return .= "</optgroup>";
    echo $return;
    exit;
}


function eh_bep_in_array_fields_check($key, $array) {
    if (in_array($key, $array)) {
        return true;
    } else {
        return false;
    }
}

//custom rounding

function eh_bep_round_ceiling($number, $significance = 1) {
    return ( is_numeric($number) && is_numeric($significance) ) ? (ceil($number / $significance) * $significance) : false;
}

function eh_bep_update_product_callback() {
    set_time_limit(300);
    check_ajax_referer('ajax-eh-bep-nonce', '_ajax_eh_bep_nonce');
    $selected_products= xa_bep_get_selected_products();
    $undo_product_data = array();
    $undo_variation_data = array();
    $product_data = array();
    $variation_data = array();
    $edit_data = array();
    $title_select = $edit_data['title_select'] = $_POST['title_select'];
    $sku_select = $edit_data['sku_select'] = $_POST['sku_select'];
    $catalog_select = $edit_data['catalog_select'] = $_POST['catalog_select'];
    $shipping_select = $edit_data['shipping_select'] = $_POST['shipping_select'];
    $sale_select = $edit_data['sale_select'] = $_POST['sale_select'];
    $sale_round_select = $edit_data['sale_round_select'] = $_POST['sale_round_select'];
    $regular_select = $edit_data['regular_select'] = $_POST['regular_select'];
    $regular_round_select = $edit_data['regular_round_select'] = $_POST['regular_round_select'];
    $stock_manage_select = $edit_data['stock_manage_select'] = $_POST['stock_manage_select'];
    $quantity_select = $edit_data['quantity_select'] = $_POST['quantity_select'];
    $backorder_select = $edit_data['backorder_select'] = $_POST['backorder_select'];
    $stock_status_select = $edit_data['stock_status_select'] = $_POST['stock_status_select'];

    $length_select = $edit_data['length_select'] = $_POST['length_select'];
    $width_select = $edit_data['width_select'] = $_POST['width_select'];
    $height_select = $edit_data['height_select'] = $_POST['height_select'];
    $weight_select = $edit_data['weight_select'] = $_POST['weight_select'];
    $title_text = $edit_data['title_text'] = sanitize_text_field($_POST['title_text']);
    $replace_title_text = $edit_data['replace_title_text'] = sanitize_text_field($_POST['replace_title_text']);
    $sku_text = $edit_data['sku_text'] = sanitize_text_field($_POST['sku_text']);
    $sku_replace_text = $edit_data['sku_replace_text'] = sanitize_text_field($_POST['sku_replace_text']);
    $sale_text = $edit_data['sale_text'] = $_POST['sale_text'];
    $sale_round_text = $edit_data['sale_round_text'] = $_POST['sale_round_text'];
    $regular_text = $edit_data['regular_text'] = $_POST['regular_text'];
    $regular_round_text = $edit_data['regular_round_text'] = $_POST['regular_round_text'];
    $quantity_text = $edit_data['quantity_text'] = $_POST['quantity_text'];
    $length_text = $edit_data['length_text'] = $_POST['length_text'];
    $width_text = $edit_data['width_text'] = $_POST['width_text'];
    $height_text = $edit_data['height_text'] = $_POST['height_text'];
    $weight_text = $edit_data['weight_text'] = $_POST['weight_text'];
    $hide_price = $edit_data['hide_price'] = $_POST['hide_price'];
    $hide_price_role = $edit_data['hide_price_role'] = ($_POST['hide_price_role'] != '') ? $_POST['hide_price_role'] : '';
    $price_adjustment = $edit_data['price_adjustment'] = $_POST['price_adjustment'];
    $shipping_unit = $edit_data['shipping_unit'] = sanitize_text_field($_POST['shipping_unit']);
    $shipping_unit_select = $edit_data['shipping_unit_select'] = $_POST['shipping_unit_select'];
    foreach($selected_products as $pid => $temp) {
        $collect_product_data = array();
        apply_filters('http_request_timeout', 30);
        switch ($hide_price) {
            case 'yes':
                $collect_product_data['product_adjustment_hide_price_unregistered'] = get_post_meta($pid, 'product_adjustment_hide_price_unregistered', true);
                eh_bep_update_meta_fn($pid, 'product_adjustment_hide_price_unregistered', 'yes');
                break;
            case 'no':
                $collect_product_data['product_adjustment_hide_price_unregistered'] = get_post_meta($pid, 'product_adjustment_hide_price_unregistered', true);
                eh_bep_update_meta_fn($pid, 'product_adjustment_hide_price_unregistered', 'no');
                break;
        }
        switch ($price_adjustment) {
            case 'yes':
                $collect_product_data['product_based_price_adjustment'] = get_post_meta($pid, 'product_based_price_adjustment', true);
                eh_bep_update_meta_fn($pid, 'product_based_price_adjustment', 'yes');
                break;
            case 'no':
                $collect_product_data['product_based_price_adjustment'] = get_post_meta($pid, 'product_based_price_adjustment', true);
                eh_bep_update_meta_fn($pid, 'product_based_price_adjustment', 'no');
                break;
        }
        if ($hide_price_role != '') {
            $collect_product_data['eh_pricing_adjustment_product_price_user_role'] = get_post_meta($pid, 'eh_pricing_adjustment_product_price_user_role', true);
            eh_bep_update_meta_fn($pid, 'eh_pricing_adjustment_product_price_user_role', $hide_price_role);
        }
        switch ($shipping_unit_select) {
            case "add":
                $unit = get_post_meta($pid, '_wf_shipping_unit', true);
                $collect_product_data['wf_shipping_unit'] = $unit;
                $unit_val = number_format($unit + $shipping_unit, 6, '.', '');
                eh_bep_update_meta_fn($pid, '_wf_shipping_unit', $unit_val);
                break;
            case "sub":
                $unit = get_post_meta($pid, '_wf_shipping_unit', true);
                $collect_product_data['wf_shipping_unit'] = $unit;
                $unit_val = number_format($unit - $shipping_unit, 6, '.', '');
                eh_bep_update_meta_fn($pid, '_wf_shipping_unit', $unit_val);
                break;
            case "replace":
                $unit = get_post_meta($pid, '_wf_shipping_unit', true);
                $collect_product_data['wf_shipping_unit'] = $unit;
                eh_bep_update_meta_fn($pid, '_wf_shipping_unit', $shipping_unit);
                break;
            default:
                break;
        }
        $temp = wc_get_product($pid);
        $parent= $temp;
        if (!empty($temp) && $temp->is_type('variation')) {
            $parent_id = (WC()->version < '2.7.0') ?  $temp->parent->id : $temp->get_parent_id();
            $parent= wc_get_product($parent_id);
        }
        $temp_type = (WC()->version < '2.7.0') ? $temp->product_type : $temp->get_type();
        $temp_title = (WC()->version < '2.7.0') ? $temp->post->post_title : $temp->get_title();
        if ($temp_type == 'simple' || $temp_type == 'variation') {
            $product_data = array();
            $product_data['type'] = 'simple';
            $product_data['title'] = $temp_title;
            $product_data['sku'] = get_post_meta($pid, '_sku', true);
            $product_data['catalog'] = (WC()->version < '3.0.0') ? get_post_meta($pid, '_visibility', true):$temp->get_catalog_visibility();
            $ship_args = array('fields' => 'ids');
            $product_data['shipping'] = current(wp_get_object_terms($pid, 'product_shipping_class', $ship_args));
            $product_data['sale'] = (float) get_post_meta($pid, '_sale_price', true);
            $product_data['regular'] = (float) get_post_meta($pid, '_regular_price', true);
            $product_data['stock_manage'] = get_post_meta($pid, '_manage_stock', true);
            $product_data['stock_quantity'] = (float) get_post_meta($pid, '_stock', true);
            $product_data['backorder'] = get_post_meta($pid, '_backorders', true);
            $product_data['stock_status'] = get_post_meta($pid, '_stock_status', true);
            $product_data['length'] = (float) get_post_meta($pid, '_length', true);
            $product_data['width'] =(float)  get_post_meta($pid, '_width', true);
            $product_data['height'] = (float) get_post_meta($pid, '_height', true);
            $product_data['weight'] = (float) get_post_meta($pid, '_weight', true);
            $collect_product_data['id'] = $pid;
            $collect_product_data['type'] = $product_data['type'];
            switch ($title_select) {
                case 'set_new':
                    $my_post = array(
                        'ID' => $pid,
                        'post_title' => $title_text
                    );
                    $collect_product_data['title'] = $product_data['title'];
                    wp_update_post($my_post);
                    break;
                case 'append':
                    $my_post = array(
                        'ID' => $pid,
                        'post_title' => $product_data['title'] . $title_text
                    );
                    $collect_product_data['title'] = $product_data['title'];
                    wp_update_post($my_post);
                    break;
                case 'prepand':
                    $my_post = array(
                        'ID' => $pid,
                        'post_title' => $title_text . $product_data['title']
                    );
                    $collect_product_data['title'] = $product_data['title'];
                    wp_update_post($my_post);
                    break;
                case 'replace':
                    $my_post = array(
                        'ID' => $pid,
                        'post_title' => str_replace($replace_title_text, $title_text, $product_data['title'])
                    );
                    $collect_product_data['title'] = $product_data['title'];
                    wp_update_post($my_post);
                    break;
            }
            switch ($sku_select) {
                case 'set_new':
                    $collect_product_data['sku'] = $product_data['sku'];
                    eh_bep_update_meta_fn($pid, '_sku', $sku_text);
                    break;
                case 'append':
                    $collect_product_data['sku'] = $product_data['sku'];
                    $sku_val = $product_data['sku'] . $sku_text;
                    eh_bep_update_meta_fn($pid, '_sku', $sku_val);
                    break;
                case 'prepand':
                    $collect_product_data['sku'] = $product_data['sku'];
                    $sku_val = $sku_text . $product_data['sku'];
                    eh_bep_update_meta_fn($pid, '_sku', $sku_val);
                    break;
                case 'replace':
                    $collect_product_data['sku'] = $product_data['sku'];
                    $sku_val = str_replace($sku_replace_text, $sku_text, $product_data['sku']);
                    eh_bep_update_meta_fn($pid, '_sku', $sku_val);
                    break;
            }
            $collect_product_data['catalog'] = $product_data['catalog'];
            if(WC()->version < '3.0.0'){
                eh_bep_update_meta_fn($pid, '_visibility', 'visible');
            }else
            {
		$options = array_keys( wc_get_product_visibility_options() );
                $catalog_select=wc_clean($catalog_select);
		if (in_array( $catalog_select, $options, true ) ) {
                    $parent->set_catalog_visibility($catalog_select);
                    $parent->save();
                }
            }

            if ($shipping_select != '') {
                $collect_product_data['shipping'] = $product_data['shipping'];
                wp_set_object_terms((int) $pid, (int) $shipping_select, 'product_shipping_class');
            }
            switch ($sale_select) {
                case 'up_percentage':
                    if ($product_data['sale'] !== '') {
                        $collect_product_data['sale'] = $product_data['sale'];
                        $per_val = $product_data['sale'] * ($sale_text / 100);
                        $cal_val = $product_data['sale'] + $per_val;
                        ;
                        if ($sale_round_select != "" && $sale_round_text != "") {
                            $got_sale = $cal_val;
                            switch ($sale_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_sale, $sale_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_sale, -$sale_round_text);
                                    break;
                            }
                        }
                        $sale_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_sale_price', $sale_val);
                    }
                    break;
                case 'down_percentage':
                    if ($product_data['sale'] !== '') {
                        $collect_product_data['sale'] = $product_data['sale'];
                        $per_val = $product_data['sale'] * ($sale_text / 100);
                        $cal_val = $product_data['sale'] - $per_val;
                        if ($sale_round_select != "" && $sale_round_text != "") {
                            $got_sale = $cal_val;
                            switch ($sale_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_sale, $sale_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_sale, -$sale_round_text);
                                    break;
                            }
                        }
                        $sale_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_sale_price', $sale_val);
                    }
                    break;
                case 'up_price':
                    if ($product_data['sale'] !== '') {
                        $collect_product_data['sale'] = $product_data['sale'];
                        $cal_val = $product_data['sale'] + $sale_text;
                        if ($sale_round_select != "" && $sale_round_text != "") {
                            $got_sale = $cal_val;
                            switch ($sale_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_sale, $sale_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_sale, -$sale_round_text);
                                    break;
                            }
                        }
                        $sale_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_sale_price', $sale_val);
                    }
                    break;
                case 'down_price':
                    if ($product_data['sale'] !== '') {
                        $collect_product_data['sale'] = $product_data['sale'];
                        $cal_val = $product_data['sale'] - $sale_text;
                        if ($sale_round_select != "" && $sale_round_text != "") {
                            $got_sale = $cal_val;
                            switch ($sale_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_sale, $sale_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_sale, -$sale_round_text);
                                    break;
                            }
                        }
                        $sale_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_sale_price', $sale_val);
                    }
                    break;
                case 'flat_all':
                    $collect_product_data['sale'] = $product_data['sale'];
                    $sale_val = wc_format_decimal($sale_text, "");
                    eh_bep_update_meta_fn($pid, '_sale_price', $sale_val);
                    break;
                case 'copy_regular':
                    $collect_product_data['sale'] = $product_data['sale'];
                    $sale_val = wc_format_decimal($product_data['regular'], "");
                    eh_bep_update_meta_fn($pid, '_sale_price', $sale_val);
            }
            switch ($regular_select) {
                case 'up_percentage':
                    if ($product_data['regular'] !== '') {
                        $collect_product_data['regular'] = $product_data['regular'];
                        $per_val = $product_data['regular'] * ($regular_text / 100);
                        $cal_val = $product_data['regular'] + $per_val;
                        if ($regular_round_select != "" && $regular_round_text != "") {
                            $got_regular = $cal_val;
                            switch ($regular_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_regular, $regular_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_regular, -$regular_round_text);
                                    break;
                            }
                        }
                        $regular_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_regular_price', $regular_val);
                    }
                    break;
                case 'down_percentage':
                    if ($product_data['regular'] !== '') {
                        $collect_product_data['regular'] = $product_data['regular'];
                        $per_val = $product_data['regular'] * ($regular_text / 100);
                        $cal_val = $product_data['regular'] - $per_val;
                        if ($regular_round_select != "" && $regular_round_text != "") {
                            $got_regular = $cal_val;
                            switch ($regular_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_regular, $regular_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_regular, -$regular_round_text);
                                    break;
                            }
                        }
                        $regular_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_regular_price', $regular_val);
                    }
                    break;
                case 'up_price':
                    if ($product_data['regular'] !== '') {
                        $collect_product_data['regular'] = $product_data['regular'];
                        $cal_val = $product_data['regular'] + $regular_text;
                        if ($regular_round_select != "" && $regular_round_text != "") {
                            $got_regular = $cal_val;
                            switch ($regular_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_regular, $regular_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_regular, -$regular_round_text);
                                    break;
                            }
                        }
                        $regular_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_regular_price', $regular_val);
                    }
                    break;
                case 'down_price':
                    if ($product_data['regular'] !== '') {
                        $collect_product_data['regular'] = $product_data['regular'];
                        $cal_val = $product_data['regular'] - $regular_text;
                        if ($regular_round_select != "" && $regular_round_text != "") {
                            $got_regular = $cal_val;
                            switch ($regular_round_select) {
                                case 'up':
                                    $cal_val = eh_bep_round_ceiling($got_regular, $regular_round_text);
                                    break;
                                case 'down':
                                    $cal_val = eh_bep_round_ceiling($got_regular, -$regular_round_text);
                                    break;
                            }
                        }
                        $regular_val = wc_format_decimal($cal_val, "");
                        eh_bep_update_meta_fn($pid, '_regular_price', $regular_val);
                    }
                    break;
                case 'flat_all':
                    $collect_product_data['regular'] = $product_data['regular'];
                    $regular_val = wc_format_decimal($regular_text, "");
                    eh_bep_update_meta_fn($pid, '_regular_price', $regular_val);
                    break;
                case 'copy_sale':
                    $collect_product_data['regular'] = $product_data['regular'];
                    $regular_val = wc_format_decimal($product_data['sale'], "");
                    eh_bep_update_meta_fn($pid, '_regular_price', $regular_val);
                    break;
            }
            if (get_post_meta($pid, '_sale_price', true) !== '' && get_post_meta($pid, '_regular_price', true) !== '') {
                eh_bep_update_meta_fn($pid, '_price', get_post_meta($pid, '_sale_price', true));
            } elseif (get_post_meta($pid, '_sale_price', true) === '' && get_post_meta($pid, '_regular_price', true) !== '') {
                eh_bep_update_meta_fn($pid, '_price', get_post_meta($pid, '_regular_price', true));
            } elseif (get_post_meta($pid, '_sale_price', true) !== '' && get_post_meta($pid, '_regular_price', true) === '') {
                eh_bep_update_meta_fn($pid, '_price', get_post_meta($pid, '_sale_price', true));
            } elseif (get_post_meta($pid, '_sale_price', true) === '' && get_post_meta($pid, '_regular_price', true) === '') {
                eh_bep_update_meta_fn($pid, '_price', '');
            }
            switch ($stock_manage_select) {
                case 'yes':
                    $collect_product_data['stock_manage'] = $product_data['stock_manage'];
                    eh_bep_update_meta_fn($pid, '_manage_stock', 'yes');
                    break;
                case 'no':
                    $collect_product_data['stock_manage'] = $product_data['stock_manage'];
                    eh_bep_update_meta_fn($pid, '_manage_stock', 'no');
                    break;
            }
            switch ($quantity_select) {
                case 'add':
                    $collect_product_data['stock_quantity'] = $product_data['stock_quantity'];
                    $quantity_val = number_format($product_data['stock_quantity'] + $quantity_text, 6, '.', '');
                    eh_bep_update_meta_fn($pid, '_stock', $quantity_val);
                    break;
                case 'sub':
                    $collect_product_data['stock_quantity'] = $product_data['stock_quantity'];
                    $quantity_val = number_format($product_data['stock_quantity'] - $quantity_text, 6, '.', '');
                    eh_bep_update_meta_fn($pid, '_stock', $quantity_val);
                    break;
                case 'replace':
                    $collect_product_data['stock_quantity'] = $product_data['stock_quantity'];
                    $quantity_val = number_format($quantity_text, 6, '.', '');
                    eh_bep_update_meta_fn($pid, '_stock', $quantity_val);
                    break;
            }
            switch ($backorder_select) {
                case 'no':
                    $collect_product_data['backorder'] = $product_data['backorder'];
                    eh_bep_update_meta_fn($pid, '_backorders', 'no');
                    break;
                case 'notify':
                    $collect_product_data['backorder'] = $product_data['backorder'];
                    eh_bep_update_meta_fn($pid, '_backorders', 'notify');
                    break;
                case 'yes':
                    $collect_product_data['backorder'] = $product_data['backorder'];
                    eh_bep_update_meta_fn($pid, '_backorders', 'yes');
                    break;
            }
            switch ($stock_status_select) {
                case 'instock':
                    $collect_product_data['stock_status'] = $product_data['stock_status'];
                    eh_bep_update_meta_fn($pid, '_stock_status', 'instock');
                    break;
                case 'outofstock':
                    $collect_product_data['stock_status'] = $product_data['stock_status'];
                    eh_bep_update_meta_fn($pid, '_stock_status', 'outofstock');
                    break;
            }
            switch ($length_select) {
                case 'add':
                    $collect_product_data['length'] = $product_data['length'];
                    $length_val = $product_data['length'] + $length_text;
                    eh_bep_update_meta_fn($pid, '_length', $length_val);
                    break;
                case 'sub':
                    $collect_product_data['length'] = $product_data['length'];
                    $length_val = $product_data['length'] - $length_text;
                    eh_bep_update_meta_fn($pid, '_length', $length_val);
                    break;
                case 'replace':
                    $collect_product_data['length'] = $product_data['length'];
                    $length_val = $length_text;
                    eh_bep_update_meta_fn($pid, '_length', $length_val);
                    break;
            }
            switch ($width_select) {
                case 'add':
                    $collect_product_data['width'] = $product_data['width'];
                    $width_val = $product_data['width'] + $width_text;
                    eh_bep_update_meta_fn($pid, '_width', $width_val);
                    break;
                case 'sub':
                    $collect_product_data['width'] = $product_data['width'];
                    $width_val = $product_data['width'] - $width_text;
                    eh_bep_update_meta_fn($pid, '_width', $width_val);
                    break;
                case 'replace':
                    $collect_product_data['width'] = $product_data['width'];
                    $width_val = $width_text;
                    eh_bep_update_meta_fn($pid, '_width', $width_val);
                    break;
            }
            switch ($height_select) {
                case 'add':
                    $collect_product_data['height'] = $product_data['height'];
                    $height_val = $product_data['height'] + $height_text;
                    eh_bep_update_meta_fn($pid, '_height', $height_val);
                    break;
                case 'sub':
                    $collect_product_data['height'] = $product_data['height'];
                    $height_val = $product_data['height'] - $height_text;
                    eh_bep_update_meta_fn($pid, '_height', $height_val);
                    break;
                case 'replace':
                    $collect_product_data['height'] = $product_data['height'];
                    $height_val = $height_text;
                    eh_bep_update_meta_fn($pid, '_height', $height_val);
                    break;
            }
            switch ($weight_select) {
                case 'add':
                    $collect_product_data['weight'] = $product_data['weight'];
                    $weight_val = $product_data['weight'] + $weight_text;
                    eh_bep_update_meta_fn($pid, '_weight', $weight_val);
                    break;
                case 'sub':
                    $collect_product_data['weight'] = $product_data['weight'];
                    $weight_val = $product_data['weight'] - $weight_text;
                    eh_bep_update_meta_fn($pid, '_weight', $weight_val);
                    break;
                case 'replace':
                    $collect_product_data['weight'] = $product_data['weight'];
                    $weight_val = $weight_text;
                    eh_bep_update_meta_fn($pid, '_weight', $weight_val);
                    break;
            }
            wc_delete_product_transients($pid);
        }
        $undo_product_data[$pid] = $collect_product_data;
    }

    die();
}

function eh_bep_update_meta_fn($id, $key, $value) {
    update_post_meta($id, $key, $value);
}

function eh_bep_list_table_all_callback() {
    check_ajax_referer('ajax-eh-bep-nonce', '_ajax_eh_bep_nonce');
    $obj = new Eh_DataTables();
    $obj->input();
    $obj->ajax_response('1');
}

function eh_clear_all_callback() {
    check_ajax_referer('ajax-eh-bep-nonce', '_ajax_eh_bep_nonce');
    update_option('eh_bulk_edit_choosed_product_id', eh_bep_get_first_products());
    $obj = new Eh_DataTables();
    $obj->input();
    $obj->ajax_response();
}

function xa_bep_get_products($per_page = 20, $page_number = 1, $pid_to_include = array()) {
    if(!empty($_REQUEST['query_all']) && $_REQUEST['query_all']==true)
    {   
        $args = array(
            'status' => array('private', 'publish'),
            'include' => $pid_to_include,
            'paginate' => true,
            'limit'    => 1000000,
            'type'      =>'simple'
        );        
    }else
    {
        $args = array(
            'status' => array('private', 'publish'),
            'limit' => $per_page,
            'page' => $page_number,
            'include' => $pid_to_include,
            'paginate' => true,
            'type'      =>'simple'
        );
    }
    $query = wc_get_products($args);
    return $query;
}

function eh_bep_search_filter_callback() {
    set_time_limit(300);
    check_ajax_referer('ajax-eh-bep-nonce', '_ajax_eh_bep_nonce');
    $obj_fil = new Eh_DataTables();
    $obj_fil->input();
    $obj_fil->ajax_response('1');
}



    function xa_bep_get_selected_products($table_obj=null)
    {
    $page_no            = !empty($_REQUEST['paged'])?$_REQUEST['paged']:1;
    $filter_range           = !empty($_REQUEST['range'])?$_REQUEST['range']:'';
    $filter_desired_price   = sanitize_text_field(!empty($_REQUEST['desired_price'])?$_REQUEST['desired_price']:'');
    $filter_minimum_price   = sanitize_text_field(!empty($_REQUEST['minimum_price'])?$_REQUEST['minimum_price']:'');
    $filter_maximum_price   = sanitize_text_field(!empty($_REQUEST['maximum_price'])?$_REQUEST['maximum_price']:'');
    $selected_products=array();
    $per_page=(get_option('eh_bulk_edit_table_row')) ? get_option('eh_bulk_edit_table_row') : 20;
    $pid_to_include=xa_bep_filter_products();
    $query= xa_bep_get_products($per_page,$page_no,$pid_to_include);
    foreach($query->products as $product){
        $price_valid=0;
        apply_filters('http_request_timeout', 30);        
        $temp_id = (WC()->version < '2.7.0') ? $product->id : $product->get_id();
        $temp_type = (WC()->version < '2.7.0') ? $product->product_type : $product->get_type();
        if ($temp_type == 'simple' ) {
            if ($filter_range != 'all' && !empty($filter_range)) {
                switch ($filter_range) {
                    case '>':
                        if ((int) $product->get_regular_price() >= (int) $filter_desired_price) {
                            $price_valid = 1;
                        }
                        break;
                    case '<':
                        if ((int) $product->get_regular_price() <= (int) $filter_desired_price) {
                            $price_valid = 1;
                        }
                        break;
                    case '=':
                        if ((int) $product->get_regular_price() == (int) $filter_desired_price) {
                            $price_valid = 1;
                        }
                        break;
                    case '|':
                        if ((int) $product->get_regular_price() >= (int) $filter_minimum_price && (int) $product->get_regular_price() <= (int) $filter_maximum_price) {
                            $price_valid = 1;
                        }
                        break;
                }
            } else {
                        $price_valid = 1;
            }
                 
            if($price_valid){
                $selected_products[$temp_id]=$product;
            }
        }
        elseif ($temp_type == 'variable') {
                $avail_variations  = $product->get_children();
                //performance tip use get_variation_prices()
                foreach ($avail_variations as $child_id) {
                    $cprod=wc_get_product($child_id);
                    if ($filter_range != 'all' && !empty($filter_range)) {
                        switch ($filter_range) {
                            case '>':
                                if ((int) $cprod->get_regular_price() >= (int) $filter_desired_price) {
                                    $price_valid = 1;
                                }
                                break;
                            case '<':
                                if ((int) $cprod->get_regular_price() <= (int) $filter_desired_price) {
                                    $price_valid = 1;
                                }
                                break;
                            case '=':
                                if ((int) $cprod->get_regular_price() == (int) $filter_desired_price) {
                                    $price_valid = 1;
                                }
                                break;
                            case '|':
                                if ((int) $cprod->get_regular_price() >= (int) $filter_minimum_price && (int) $cprod->get_regular_price() <= (int) $filter_maximum_price) {
                                    $price_valid = 1;
                                }
                                break;
                        }
                    } else {
                        $price_valid = 1;
                    }
                    if($price_valid)
                    { 
                        $selected_products[$child_id]=$cprod;
                        $query->total+=1;
                    }
                }
                    $query->total-=1;                   
        }        
    }
    $total_items=!empty($query->total)?$query->total:0;
    $ele_on_page=count($selected_products);
    $total_pages=!empty($query->max_num_pages)?$query->max_num_pages:1;
    if(!empty($table_obj))
    {   
        $table_obj->set_pagination_args(array(
            'total_items' => $total_items,
            'per_page' => $ele_on_page,
            'total_pages' => $total_pages
        ));        
    }
    return $selected_products;
    }
    
    
    function xa_bep_filter_products() {
        global $wpdb;
        $prefix = $wpdb->prefix;
        $sql = "SELECT 
                    DISTINCT ID 
                FROM {$prefix}posts 
                    LEFT JOIN {$prefix}term_relationships on {$prefix}term_relationships.object_id={$prefix}posts.ID 
                    LEFT JOIN {$prefix}terms on {$prefix}terms.term_id = {$prefix}term_relationships.term_taxonomy_id 
                    LEFT JOIN {$prefix}term_taxonomy on {$prefix}term_taxonomy.term_taxonomy_id={$prefix}term_relationships.term_taxonomy_id 
                WHERE  post_type = 'product' AND post_status='publish' ";
        $attr_condition = "";
        if (!empty($_REQUEST['attribute_value']) && is_array($_REQUEST['attribute_value'])) {
            $attribute_value = implode(",", $_REQUEST['attribute_value']);
            $attribute_value   =   stripslashes($attribute_value);
            $attr_condition=" CONCAT(taxonomy,':',slug)  in ({$attribute_value}) ";
        } 
        $category_condition = "";
        if (!empty($_REQUEST['category']) && is_array($_REQUEST['category'])) {
            $category = implode(",", $_REQUEST['category']);
            $category   =   stripslashes($category);
            $category_condition=" taxonomy='product_cat' AND slug  in ({$category}) ";
        }
        $product_type_condition = "";
        if (!empty($_REQUEST['type'])) {
            $product_type = stripslashes($_REQUEST['type']);
            $product_type_condition=" taxonomy='product_type'  AND slug  in ({$product_type}) ";
        } else {
            $product_type_condition=" taxonomy='product_type'  AND slug  in ('simple','variable') ";
        }

        if(!empty($attr_condition) && !empty($category_condition))
        {
            $main_query=$sql ." AND ". $attr_condition . " AND ID IN (".    $sql  ." AND ". $category_condition." AND ID IN (" .   $sql  ." AND ". $product_type_condition . "))";
        }elseif(!empty($attr_condition) && empty($category_condition))
        {
            $main_query=$sql ." AND ". $attr_condition . " AND ID IN (" .   $sql  ." AND ". $product_type_condition . ")";
        }elseif(!empty($category_condition) && empty($attr_condition))
        {
            $main_query=$sql ." AND ". $category_condition." AND ID IN (" .   $sql  ." AND ". $product_type_condition . ")";
        }else
        {  
            $main_query=$sql  ." AND ". $product_type_condition ;
        }
        $result = $wpdb->get_results($main_query, ARRAY_A);
        $ids = wp_list_pluck($result, 'ID');
        if(empty($ids)){
            return array(0);
        }
        return $ids;
    }
